/* apccomm_am_main.c
   Part of "APCComm" 
   Copyright (C) 2000,2001 Ralf Hoffmann
   Contact: ralf.hoffmann@epost.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
*/

#include "apccomm_am.h"

int main(int argc,char **argv)
{
  int s1;
  int sendfile,getfile;
  int bytecyc;
  int outchecksum,inchecksum,checksum,wrong,tc;
  int size,recbytes,sendbytes,ts;
  double d1;
  ULONG secss,secso,secsi,secs;
  ULONG usecss,usecso,usecsi,usecs;
  int sendfin,recfin,count;
  char outbuf[128],sendbuf[128],recvbuf[128],*cwd,*tstr;
  int pos=0,cwdsize;
  char *outbasename;

  if(argc>1) {
    for(s1=1;s1<argc;s1++) {
      if((strncmp(argv[s1],"-h",2)==0)||(strncmp(argv[s1],"--help",6)==0)) {
        printf("\nAPCComm by Ralf Hoffmann\n");
        printf("  Usage: %s [<filename>]\t\tTransfer \"filename\" to the PC\n",argv[0]);
        printf("         %s -h, --help\t\tShow this help\n",argv[0]);
        printf("         %s -v, --version\tShow program-version\n",argv[0]);
        printf("  When starting without args, APCComm will only receive a file from the PC\n");
        exit(0);
      } else if((strncmp(argv[s1],"-v",2)==0)||(strncmp(argv[s1],"--version",6)==0)) {
        printf("\nAPCComm by Ralf Hoffmann\n  Executable for Amiga-Side\n  Version %d.%d.%d\n",MAJOR,MINOR,PATCH);
        printf("\n  Programm for transfering files between Amiga and PC\n");
        printf("  Contact: ralf.hoffmann@epost.de\n");
        exit(0);
      }
    }
  }

  if(init_transferblocks()!=0) {
    fprintf(stderr,"Not enough mem in main()!\nExiting\n");
    exit(1);
  }

  /* Parallelport initieren */
  *ddrb=0xff;
  *ddra=0x00;
  printf("Waiting for PC:");
  fflush(stdout);
  synchro();
  printf("\nConnection established\n");

  sendfile=getfile=0;
  if(argc>1) {
    /* Datei zu uebertargen */
    if(init_outgoing_file(argv[1])!=0) {
      printf("can't open file %s!\n",argv[1]);
    } else {
      sendfile=1;
      printf("sending file \"%s\", size %d\n",argv[1],outfile.size);
    }
  }
  checksum=0;
  bytecyc=0;
  putint(outblock,sendfile);
  if(sendfile==1) {
    outbasename=strrchr(argv[1],'/');
    if(outbasename==NULL) {
      outbasename=strrchr(argv[1],':');
      if(outbasename==NULL) outbasename=argv[1];
      else outbasename++;
    } else outbasename++;
    putint(outblock+4,strlen(outbasename));
    strncpy(outblock+8,outbasename,TRANSFERBLOCKSIZE-12);
    putint(outblock+TRANSFERBLOCKSIZE-4,outfile.size);
  }
  transferblock();
  if(getint(inblock)==1) {
    if((sendfile==1)&&(strcmp(argv[1],inblock+8)==0)) {
      printf("Sending and receiving same file, Aborting\n");
      getfile=sendfile=0;
      close_outgoing_file();
    } else {
      size=getint(inblock+TRANSFERBLOCKSIZE/2-4);
      printf("receiving file \"%s\", size %d\n",inblock+8,size);
      init_incoming_file(inblock+8);
      getfile=1;
    }
  }
  transferblock();
  if((sendfile==0)&&(getfile==0)) {
    printf("Nothing to do!\n");
  } else {
    /* preparing progress display */
    if(sendfile!=0) {
      sprintf(outbuf,"%d",outfile.size);
      sprintf(sendbuf,"SEND: %%%dd/%%%dd (%%3d%%%%)",strlen(outbuf),strlen(outbuf));
      pos=6+strlen(outbuf)+1+strlen(outbuf)+2+3+1+1;
    }
    if(getfile!=0) {
      sprintf(outbuf,"%d",size);
      sprintf(recvbuf,"RECV: %%%dd/%%%dd (%%3d%%%%)",strlen(outbuf),strlen(outbuf));
    }

    printf("Starting transfer\n");
    inchecksum=outchecksum=0;
    recbytes=sendbytes=0;
    wrong=0;
    sendfin=recfin=0;
    CurrentTime(&secss,&usecss);
    for(count=0;((getfile==1)||(sendfile==1));count++) {
      if(sendfile==1) {
        ts=readtobuffer(outblock,TRANSFERBLOCKSIZE-4,&outchecksum);
        sendbytes+=ts;
        if(ts<1) sendfile=2;
        if(wrong==0) putint(outblock+TRANSFERBLOCKSIZE-4,outchecksum);
        else putint(outblock+TRANSFERBLOCKSIZE-4,0xffffffff);
      }
      if((sendfile==1)||(getfile==1)) transferblock();
      tc=getint(inblock+TRANSFERBLOCKSIZE/2-4);
      if(tc==0xffffffff) wrong=2;
      if(wrong!=0) break;
      if(getfile==1) {
        if(recbytes<size) {
          s1=size-recbytes;
          if(s1>TRANSFERBLOCKSIZE/2-4) s1=TRANSFERBLOCKSIZE/2-4;
          else getfile=2;
          writefrombuffer(inblock,s1,&inchecksum);
          recbytes+=s1;
          checksum=inchecksum-tc;
          if(checksum!=0) wrong=1;
        }
      }
      if((sendfile>1)&&(sendfin<1)) {
        CurrentTime(&secso,&usecso);
        sendfin=1;
      }
      if((getfile>1)&&(recfin<1)) {
        CurrentTime(&secsi,&usecsi);
        recfin=1;
      }
      if((count==19)||((sendfile!=1)&&(getfile!=1))) {
        count=0;
        if((sendfile>0)&&(sendfin<2)) {
	  sprintf(outbuf,sendbuf,sendbytes,outfile.size,(sendbytes*100)/outfile.size);
	}
        if((getfile>0)&&(recfin<2)) {
	  if(pos>0) {
	    strcpy(outbuf+pos," - ");
	    sprintf(outbuf+pos+3,recvbuf,recbytes,size,(recbytes*100)/size);
	  } else sprintf(outbuf,recvbuf,recbytes,size,(recbytes*100)/size);
	}
	printf("\r%s",outbuf);
        fflush(stdout);
        if(sendfin==1) sendfin=2;
        if(recfin==1) recfin=2;
      }
    }
    printf("\nTransfer finished\n");
    if(wrong==1) {
      printf("Error while transfer\nI have received wrong datas!\n");
      printf("Please repeat transmission!\n");
    } else if(wrong==2) {
      printf("Error while transfer\nThe PC reports data loss!\n");
      printf("Please repeat transmission!\n");
    } else {
      if(sendfile>0) {
        secs=secso-secss;
        usecs=usecso-usecss;
        if(usecs<0) {
          secs--;
          usecs+=1000000;
        }
        d1=outfile.size;
        d1*=1000000;
        d1/=(secs*1000000.0+usecs);
        d1/=1024;
        printf("File sended with %d KBytes/s\n",(int)d1);
      }
      if(getfile>0) {
        secs=secsi-secss;
        usecs=usecsi-usecss;
        if(usecs<0) {
          secs--;
          usecs+=1000000;
        }
        d1=size;
        d1*=1000000;
        d1/=(secs*1000000.0+usecs);
        d1/=1024;
        printf("File received with %d KBytes/s\n",(int)d1);
      }
    }
    if(sendfile>0) {
      close_outgoing_file();
      free(outfile.name);
    }
    if(getfile>0) {
      close_incoming_file();
      
      cwdsize=1024;
      cwd=(char*)malloc(cwdsize);
      if(cwd!=NULL) {
        while(getcwd(cwd,cwdsize)==NULL) {
	  if(errno==ERANGE) {
	    free(cwd);
	    cwdsize*=2;
	    cwd=(char*)malloc(cwdsize);
	    if(cwd==NULL) break;
	  } else {
	    free(cwd);
	    cwd=NULL;
	  }
	}
	if(cwd!=NULL) {
	  if(cwd[strlen(cwd)-1]==':') {
	    tstr=(char*)malloc(strlen(cwd)+strlen(infile.name)+1);
	    if(tstr!=NULL) sprintf(tstr,"%s%s",cwd,infile.name);
	  } else {
	    tstr=(char*)malloc(strlen(cwd)+1+strlen(infile.name)+1);
	    if(tstr!=NULL) sprintf(tstr,"%s/%s",cwd,infile.name);
	  }
	  if(tstr!=NULL) {
	    printf("Incoming file is stored at: %s\n",tstr);
	    free(tstr);
	  }
	}
      }
      
      free(infile.name);
    }
  }
  free(inblock);
  free(outblock);
  return 0;
}

